package dev.shadowsoffire.apotheosis.adventure.socket;

import net.minecraft.world.item.crafting.Recipe;
import net.minecraft.network.FriendlyByteBuf;
import com.google.gson.JsonElement;
import net.minecraftforge.common.crafting.CraftingHelper;
import net.minecraft.util.GsonHelper;
import com.google.gson.JsonObject;
import net.minecraft.world.item.crafting.RecipeSerializer;
import net.minecraft.core.RegistryAccess;
import dev.shadowsoffire.apotheosis.adventure.loot.LootCategory;
import net.minecraft.world.level.Level;
import net.minecraft.world.Container;
import net.minecraft.world.item.ItemStack;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.item.crafting.Ingredient;
import dev.shadowsoffire.apotheosis.adventure.AdventureModule;

public class AddSocketsRecipe extends AdventureModule.ApothSmithingRecipe
{
    private final Ingredient input;
    private final int maxSockets;
    
    public AddSocketsRecipe(final ResourceLocation id, final Ingredient input, final int maxSockets) {
        super(id, Ingredient.f_43901_, input, ItemStack.f_41583_);
        this.input = input;
        this.maxSockets = maxSockets;
    }
    
    public boolean m_5818_(final Container pInv, final Level level) {
        final ItemStack in = pInv.m_8020_(1);
        return !LootCategory.forItem(in).isNone() && SocketHelper.getSockets(in) < this.getMaxSockets() && this.getInput().test(pInv.m_8020_(2));
    }
    
    public ItemStack m_5874_(final Container pInv, final RegistryAccess regs) {
        final ItemStack out = pInv.m_8020_(1).m_41777_();
        if (out.m_41619_()) {
            return ItemStack.f_41583_;
        }
        final int sockets = SocketHelper.getSockets(out) + 1;
        SocketHelper.setSockets(out, sockets);
        return out;
    }
    
    public RecipeSerializer<?> m_7707_() {
        return (RecipeSerializer<?>)Serializer.INSTANCE;
    }
    
    public boolean m_5598_() {
        return true;
    }
    
    public Ingredient getInput() {
        return this.input;
    }
    
    public int getMaxSockets() {
        return this.maxSockets;
    }
    
    public static class Serializer implements RecipeSerializer<AddSocketsRecipe>
    {
        public static Serializer INSTANCE;
        
        public AddSocketsRecipe fromJson(final ResourceLocation id, final JsonObject obj) {
            final Ingredient item = CraftingHelper.getIngredient((JsonElement)GsonHelper.m_13930_(obj, "input"), false);
            final int maxSockets = obj.get("max_sockets").getAsInt();
            return new AddSocketsRecipe(id, item, maxSockets);
        }
        
        public AddSocketsRecipe fromNetwork(final ResourceLocation id, final FriendlyByteBuf buf) {
            return new AddSocketsRecipe(id, Ingredient.m_43940_(buf), buf.readInt());
        }
        
        public void toNetwork(final FriendlyByteBuf buf, final AddSocketsRecipe recipe) {
            recipe.input.m_43923_(buf);
            buf.writeInt(recipe.getMaxSockets());
        }
        
        static {
            Serializer.INSTANCE = new Serializer();
        }
    }
}
